package com.analogbit.puzzletools.client.slidingblocks.gui;

import com.google.gwt.user.client.ui.AbsolutePanel;
import com.google.gwt.user.client.ui.Widget;

/**
 * The grid containing the initial setup that is dragged onto the key grid. 
 */
public class KeySourceGridDisplay extends GridDisplay {

	public KeySourceGridDisplay(AbsolutePanel dragBoundary) {
		super(dragBoundary, false);
	}

	@Override
	public void add(Widget w) {
		super.add(w);
		
		if (w instanceof GridBlock) {
			GridBlock g = (GridBlock)((GridBlock)w).deepClone();
			super.add(g);
			updateGridBlockPosition(g);
		}
	}


	@Override
	public boolean isDraggable(GridBlock block) {
		return !block.getSourceBlock().isImmobile();
	}

	@Override
	public boolean isHighlightable(GridBlock block) {
		return !block.getSourceBlock().isImmobile();
	}

}
